//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ncatPriceFloater[] cachencatPriceFloater = null;

        private static ncatPriceFloater checkncatPriceFloater = new ncatPriceFloater();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ncatPriceFloater ncatPriceFloater(int length, Color lineColor, bool shortLogo, int width)
        {
            return ncatPriceFloater(Input, length, lineColor, shortLogo, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ncatPriceFloater ncatPriceFloater(Data.IDataSeries input, int length, Color lineColor, bool shortLogo, int width)
        {
            if (cachencatPriceFloater != null)
                for (int idx = 0; idx < cachencatPriceFloater.Length; idx++)
                    if (cachencatPriceFloater[idx].Length == length && cachencatPriceFloater[idx].LineColor == lineColor && cachencatPriceFloater[idx].ShortLogo == shortLogo && cachencatPriceFloater[idx].Width == width && cachencatPriceFloater[idx].EqualsInput(input))
                        return cachencatPriceFloater[idx];

            lock (checkncatPriceFloater)
            {
                checkncatPriceFloater.Length = length;
                length = checkncatPriceFloater.Length;
                checkncatPriceFloater.LineColor = lineColor;
                lineColor = checkncatPriceFloater.LineColor;
                checkncatPriceFloater.ShortLogo = shortLogo;
                shortLogo = checkncatPriceFloater.ShortLogo;
                checkncatPriceFloater.Width = width;
                width = checkncatPriceFloater.Width;

                if (cachencatPriceFloater != null)
                    for (int idx = 0; idx < cachencatPriceFloater.Length; idx++)
                        if (cachencatPriceFloater[idx].Length == length && cachencatPriceFloater[idx].LineColor == lineColor && cachencatPriceFloater[idx].ShortLogo == shortLogo && cachencatPriceFloater[idx].Width == width && cachencatPriceFloater[idx].EqualsInput(input))
                            return cachencatPriceFloater[idx];

                ncatPriceFloater indicator = new ncatPriceFloater();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Length = length;
                indicator.LineColor = lineColor;
                indicator.ShortLogo = shortLogo;
                indicator.Width = width;
                Indicators.Add(indicator);
                indicator.SetUp();

                ncatPriceFloater[] tmp = new ncatPriceFloater[cachencatPriceFloater == null ? 1 : cachencatPriceFloater.Length + 1];
                if (cachencatPriceFloater != null)
                    cachencatPriceFloater.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachencatPriceFloater = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ncatPriceFloater ncatPriceFloater(int length, Color lineColor, bool shortLogo, int width)
        {
            return _indicator.ncatPriceFloater(Input, length, lineColor, shortLogo, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ncatPriceFloater ncatPriceFloater(Data.IDataSeries input, int length, Color lineColor, bool shortLogo, int width)
        {
            return _indicator.ncatPriceFloater(input, length, lineColor, shortLogo, width);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ncatPriceFloater ncatPriceFloater(int length, Color lineColor, bool shortLogo, int width)
        {
            return _indicator.ncatPriceFloater(Input, length, lineColor, shortLogo, width);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ncatPriceFloater ncatPriceFloater(Data.IDataSeries input, int length, Color lineColor, bool shortLogo, int width)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ncatPriceFloater(input, length, lineColor, shortLogo, width);
        }
    }
}
#endregion
